// Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
// Copyright 2022-2025 Advanced Micro Devices, Inc. All Rights Reserved.
// --------------------------------------------------------------------------------
// Tool Version: Vivado v.2025.1 (win64) Build 6140274 Thu May 22 00:12:29 MDT 2025
// Date        : Sun Jan  4 13:07:45 2026
// Host        : LAPTOP-L3CRKKNJ running 64-bit major release  (build 9200)
// Command     : write_verilog -force -mode funcsim
//               c:/Vivado_Debug/PLLXplore_FNPLL/FNPLL2.gen/sources_1/bd/FNPLL/ip/FNPLL_digital_loop_filter_0_0/FNPLL_digital_loop_filter_0_0_sim_netlist.v
// Design      : FNPLL_digital_loop_filter_0_0
// Purpose     : This verilog netlist is a functional simulation representation of the design and should not be modified
//               or synthesized. This netlist cannot be used for SDF annotated simulation.
// Device      : xc7a35tcpg236-1
// --------------------------------------------------------------------------------
`timescale 1 ps / 1 ps

(* CHECK_LICENSE_TYPE = "FNPLL_digital_loop_filter_0_0,digital_loop_filter,{}" *) (* downgradeipidentifiedwarnings = "yes" *) (* ip_definition_source = "module_ref" *) 
(* x_core_info = "digital_loop_filter,Vivado 2025.1" *) 
(* NotValidForBitStream *)
module FNPLL_digital_loop_filter_0_0
   (clk,
    rst_n,
    pfd_up,
    pfd_dn,
    ctrl_out);
  (* x_interface_info = "xilinx.com:signal:clock:1.0 clk CLK" *) (* x_interface_mode = "slave clk" *) (* x_interface_parameter = "XIL_INTERFACENAME clk, FREQ_HZ 200000000, FREQ_TOLERANCE_HZ 0, PHASE 0.0, CLK_DOMAIN /clk_wiz_0_clk_out1, INSERT_VIP 0" *) input clk;
  (* x_interface_info = "xilinx.com:signal:reset:1.0 rst_n RST" *) (* x_interface_mode = "slave rst_n" *) (* x_interface_parameter = "XIL_INTERFACENAME rst_n, POLARITY ACTIVE_LOW, INSERT_VIP 0" *) input rst_n;
  input pfd_up;
  input pfd_dn;
  output [15:0]ctrl_out;

  wire clk;
  wire [15:0]ctrl_out;
  wire pfd_dn;
  wire pfd_up;
  wire rst_n;

  FNPLL_digital_loop_filter_0_0_digital_loop_filter U0
       (.clk(clk),
        .ctrl_out(ctrl_out),
        .pfd_dn(pfd_dn),
        .pfd_up(pfd_up),
        .rst_n(rst_n));
endmodule

(* ORIG_REF_NAME = "digital_loop_filter" *) 
module FNPLL_digital_loop_filter_0_0_digital_loop_filter
   (ctrl_out,
    pfd_dn,
    pfd_up,
    rst_n,
    clk);
  output [15:0]ctrl_out;
  input pfd_dn;
  input pfd_up;
  input rst_n;
  input clk;

  wire ARG_carry__0_i_1_n_0;
  wire ARG_carry__0_i_2_n_0;
  wire ARG_carry__0_i_3_n_0;
  wire ARG_carry__0_i_4_n_0;
  wire ARG_carry__0_n_0;
  wire ARG_carry__0_n_1;
  wire ARG_carry__0_n_2;
  wire ARG_carry__0_n_3;
  wire ARG_carry__0_n_4;
  wire ARG_carry__0_n_5;
  wire ARG_carry__0_n_6;
  wire ARG_carry__0_n_7;
  wire ARG_carry__1_i_1_n_0;
  wire ARG_carry__1_i_2_n_0;
  wire ARG_carry__1_i_3_n_0;
  wire ARG_carry__1_i_4_n_0;
  wire ARG_carry__1_n_0;
  wire ARG_carry__1_n_1;
  wire ARG_carry__1_n_2;
  wire ARG_carry__1_n_3;
  wire ARG_carry__1_n_4;
  wire ARG_carry__1_n_5;
  wire ARG_carry__1_n_6;
  wire ARG_carry__1_n_7;
  wire ARG_carry__2_i_1_n_0;
  wire ARG_carry__2_i_2_n_0;
  wire ARG_carry__2_i_3_n_0;
  wire ARG_carry__2_i_4_n_0;
  wire ARG_carry__2_n_0;
  wire ARG_carry__2_n_1;
  wire ARG_carry__2_n_2;
  wire ARG_carry__2_n_3;
  wire ARG_carry__2_n_4;
  wire ARG_carry__2_n_5;
  wire ARG_carry__2_n_6;
  wire ARG_carry__2_n_7;
  wire ARG_carry__3_i_1_n_0;
  wire ARG_carry__3_i_2_n_0;
  wire ARG_carry__3_i_3_n_0;
  wire ARG_carry__3_i_4_n_0;
  wire ARG_carry__3_n_0;
  wire ARG_carry__3_n_1;
  wire ARG_carry__3_n_2;
  wire ARG_carry__3_n_3;
  wire ARG_carry__3_n_4;
  wire ARG_carry__3_n_5;
  wire ARG_carry__3_n_6;
  wire ARG_carry__3_n_7;
  wire ARG_carry__4_i_1_n_0;
  wire ARG_carry__4_i_2_n_0;
  wire ARG_carry__4_i_3_n_0;
  wire ARG_carry__4_i_4_n_0;
  wire ARG_carry__4_n_0;
  wire ARG_carry__4_n_1;
  wire ARG_carry__4_n_2;
  wire ARG_carry__4_n_3;
  wire ARG_carry__4_n_4;
  wire ARG_carry__4_n_5;
  wire ARG_carry__4_n_6;
  wire ARG_carry__4_n_7;
  wire ARG_carry__5_i_1_n_0;
  wire ARG_carry__5_i_2_n_0;
  wire ARG_carry__5_i_3_n_0;
  wire ARG_carry__5_i_4_n_0;
  wire ARG_carry__5_n_0;
  wire ARG_carry__5_n_1;
  wire ARG_carry__5_n_2;
  wire ARG_carry__5_n_3;
  wire ARG_carry__5_n_4;
  wire ARG_carry__5_n_5;
  wire ARG_carry__5_n_6;
  wire ARG_carry__5_n_7;
  wire ARG_carry__6_i_1_n_0;
  wire ARG_carry__6_i_2_n_0;
  wire ARG_carry__6_i_3_n_0;
  wire ARG_carry__6_n_2;
  wire ARG_carry__6_n_3;
  wire ARG_carry__6_n_6;
  wire ARG_carry__6_n_7;
  wire ARG_carry_i_1_n_0;
  wire ARG_carry_i_2_n_0;
  wire ARG_carry_i_3_n_0;
  wire ARG_carry_i_4_n_0;
  wire ARG_carry_i_5_n_0;
  wire ARG_carry_n_0;
  wire ARG_carry_n_1;
  wire ARG_carry_n_2;
  wire ARG_carry_n_3;
  wire clk;
  wire [15:0]ctrl_out;
  wire in0;
  wire \integrator[12]_i_2_n_0 ;
  wire \integrator[12]_i_3_n_0 ;
  wire \integrator[12]_i_4_n_0 ;
  wire \integrator[12]_i_5_n_0 ;
  wire \integrator[16]_i_2_n_0 ;
  wire \integrator[16]_i_3_n_0 ;
  wire \integrator[16]_i_4_n_0 ;
  wire \integrator[16]_i_5_n_0 ;
  wire \integrator[1]_i_2_n_0 ;
  wire \integrator[1]_i_3_n_0 ;
  wire \integrator[1]_i_4_n_0 ;
  wire \integrator[20]_i_2_n_0 ;
  wire \integrator[20]_i_3_n_0 ;
  wire \integrator[20]_i_4_n_0 ;
  wire \integrator[20]_i_5_n_0 ;
  wire \integrator[24]_i_2_n_0 ;
  wire \integrator[24]_i_3_n_0 ;
  wire \integrator[24]_i_4_n_0 ;
  wire \integrator[24]_i_5_n_0 ;
  wire \integrator[28]_i_2_n_0 ;
  wire \integrator[28]_i_3_n_0 ;
  wire \integrator[28]_i_4_n_0 ;
  wire \integrator[28]_i_5_n_0 ;
  wire \integrator[4]_i_2_n_0 ;
  wire \integrator[4]_i_3_n_0 ;
  wire \integrator[4]_i_4_n_0 ;
  wire \integrator[4]_i_5_n_0 ;
  wire \integrator[8]_i_2_n_0 ;
  wire \integrator[8]_i_3_n_0 ;
  wire \integrator[8]_i_4_n_0 ;
  wire \integrator[8]_i_5_n_0 ;
  wire [31:1]integrator_reg;
  wire \integrator_reg[12]_i_1_n_0 ;
  wire \integrator_reg[12]_i_1_n_1 ;
  wire \integrator_reg[12]_i_1_n_2 ;
  wire \integrator_reg[12]_i_1_n_3 ;
  wire \integrator_reg[12]_i_1_n_4 ;
  wire \integrator_reg[12]_i_1_n_5 ;
  wire \integrator_reg[12]_i_1_n_6 ;
  wire \integrator_reg[12]_i_1_n_7 ;
  wire \integrator_reg[16]_i_1_n_0 ;
  wire \integrator_reg[16]_i_1_n_1 ;
  wire \integrator_reg[16]_i_1_n_2 ;
  wire \integrator_reg[16]_i_1_n_3 ;
  wire \integrator_reg[16]_i_1_n_4 ;
  wire \integrator_reg[16]_i_1_n_5 ;
  wire \integrator_reg[16]_i_1_n_6 ;
  wire \integrator_reg[16]_i_1_n_7 ;
  wire \integrator_reg[1]_i_1_n_0 ;
  wire \integrator_reg[1]_i_1_n_1 ;
  wire \integrator_reg[1]_i_1_n_2 ;
  wire \integrator_reg[1]_i_1_n_3 ;
  wire \integrator_reg[1]_i_1_n_4 ;
  wire \integrator_reg[1]_i_1_n_5 ;
  wire \integrator_reg[1]_i_1_n_6 ;
  wire \integrator_reg[20]_i_1_n_0 ;
  wire \integrator_reg[20]_i_1_n_1 ;
  wire \integrator_reg[20]_i_1_n_2 ;
  wire \integrator_reg[20]_i_1_n_3 ;
  wire \integrator_reg[20]_i_1_n_4 ;
  wire \integrator_reg[20]_i_1_n_5 ;
  wire \integrator_reg[20]_i_1_n_6 ;
  wire \integrator_reg[20]_i_1_n_7 ;
  wire \integrator_reg[24]_i_1_n_0 ;
  wire \integrator_reg[24]_i_1_n_1 ;
  wire \integrator_reg[24]_i_1_n_2 ;
  wire \integrator_reg[24]_i_1_n_3 ;
  wire \integrator_reg[24]_i_1_n_4 ;
  wire \integrator_reg[24]_i_1_n_5 ;
  wire \integrator_reg[24]_i_1_n_6 ;
  wire \integrator_reg[24]_i_1_n_7 ;
  wire \integrator_reg[28]_i_1_n_1 ;
  wire \integrator_reg[28]_i_1_n_2 ;
  wire \integrator_reg[28]_i_1_n_3 ;
  wire \integrator_reg[28]_i_1_n_4 ;
  wire \integrator_reg[28]_i_1_n_5 ;
  wire \integrator_reg[28]_i_1_n_6 ;
  wire \integrator_reg[28]_i_1_n_7 ;
  wire \integrator_reg[4]_i_1_n_0 ;
  wire \integrator_reg[4]_i_1_n_1 ;
  wire \integrator_reg[4]_i_1_n_2 ;
  wire \integrator_reg[4]_i_1_n_3 ;
  wire \integrator_reg[4]_i_1_n_4 ;
  wire \integrator_reg[4]_i_1_n_5 ;
  wire \integrator_reg[4]_i_1_n_6 ;
  wire \integrator_reg[4]_i_1_n_7 ;
  wire \integrator_reg[8]_i_1_n_0 ;
  wire \integrator_reg[8]_i_1_n_1 ;
  wire \integrator_reg[8]_i_1_n_2 ;
  wire \integrator_reg[8]_i_1_n_3 ;
  wire \integrator_reg[8]_i_1_n_4 ;
  wire \integrator_reg[8]_i_1_n_5 ;
  wire \integrator_reg[8]_i_1_n_6 ;
  wire \integrator_reg[8]_i_1_n_7 ;
  wire \lpf_acc[0]_i_2_n_0 ;
  wire \lpf_acc[0]_i_3_n_0 ;
  wire \lpf_acc[0]_i_4_n_0 ;
  wire \lpf_acc[0]_i_5_n_0 ;
  wire \lpf_acc[12]_i_2_n_0 ;
  wire \lpf_acc[12]_i_3_n_0 ;
  wire \lpf_acc[12]_i_4_n_0 ;
  wire \lpf_acc[12]_i_5_n_0 ;
  wire \lpf_acc[19]_i_2_n_0 ;
  wire \lpf_acc[19]_i_3_n_0 ;
  wire \lpf_acc[19]_i_4_n_0 ;
  wire \lpf_acc[19]_i_5_n_0 ;
  wire \lpf_acc[23]_i_2_n_0 ;
  wire \lpf_acc[23]_i_3_n_0 ;
  wire \lpf_acc[23]_i_4_n_0 ;
  wire \lpf_acc[23]_i_5_n_0 ;
  wire \lpf_acc[27]_i_2_n_0 ;
  wire \lpf_acc[27]_i_3_n_0 ;
  wire \lpf_acc[27]_i_4_n_0 ;
  wire \lpf_acc[27]_i_5_n_0 ;
  wire \lpf_acc[31]_i_2_n_0 ;
  wire \lpf_acc[31]_i_3_n_0 ;
  wire \lpf_acc[31]_i_4_n_0 ;
  wire \lpf_acc[31]_i_5_n_0 ;
  wire \lpf_acc[4]_i_2_n_0 ;
  wire \lpf_acc[4]_i_3_n_0 ;
  wire \lpf_acc[4]_i_4_n_0 ;
  wire \lpf_acc[4]_i_5_n_0 ;
  wire \lpf_acc[8]_i_2_n_0 ;
  wire \lpf_acc[8]_i_3_n_0 ;
  wire \lpf_acc[8]_i_4_n_0 ;
  wire \lpf_acc[8]_i_5_n_0 ;
  wire [15:0]lpf_acc_reg;
  wire \lpf_acc_reg[0]_i_1_n_0 ;
  wire \lpf_acc_reg[0]_i_1_n_1 ;
  wire \lpf_acc_reg[0]_i_1_n_2 ;
  wire \lpf_acc_reg[0]_i_1_n_3 ;
  wire \lpf_acc_reg[0]_i_1_n_4 ;
  wire \lpf_acc_reg[0]_i_1_n_5 ;
  wire \lpf_acc_reg[0]_i_1_n_6 ;
  wire \lpf_acc_reg[0]_i_1_n_7 ;
  wire \lpf_acc_reg[12]_i_1_n_0 ;
  wire \lpf_acc_reg[12]_i_1_n_1 ;
  wire \lpf_acc_reg[12]_i_1_n_2 ;
  wire \lpf_acc_reg[12]_i_1_n_3 ;
  wire \lpf_acc_reg[12]_i_1_n_4 ;
  wire \lpf_acc_reg[12]_i_1_n_5 ;
  wire \lpf_acc_reg[12]_i_1_n_6 ;
  wire \lpf_acc_reg[12]_i_1_n_7 ;
  wire \lpf_acc_reg[19]_i_1_n_0 ;
  wire \lpf_acc_reg[19]_i_1_n_1 ;
  wire \lpf_acc_reg[19]_i_1_n_2 ;
  wire \lpf_acc_reg[19]_i_1_n_3 ;
  wire \lpf_acc_reg[19]_i_1_n_4 ;
  wire \lpf_acc_reg[19]_i_1_n_5 ;
  wire \lpf_acc_reg[19]_i_1_n_6 ;
  wire \lpf_acc_reg[19]_i_1_n_7 ;
  wire \lpf_acc_reg[23]_i_1_n_0 ;
  wire \lpf_acc_reg[23]_i_1_n_1 ;
  wire \lpf_acc_reg[23]_i_1_n_2 ;
  wire \lpf_acc_reg[23]_i_1_n_3 ;
  wire \lpf_acc_reg[23]_i_1_n_4 ;
  wire \lpf_acc_reg[23]_i_1_n_5 ;
  wire \lpf_acc_reg[23]_i_1_n_6 ;
  wire \lpf_acc_reg[23]_i_1_n_7 ;
  wire \lpf_acc_reg[27]_i_1_n_0 ;
  wire \lpf_acc_reg[27]_i_1_n_1 ;
  wire \lpf_acc_reg[27]_i_1_n_2 ;
  wire \lpf_acc_reg[27]_i_1_n_3 ;
  wire \lpf_acc_reg[27]_i_1_n_4 ;
  wire \lpf_acc_reg[27]_i_1_n_5 ;
  wire \lpf_acc_reg[27]_i_1_n_6 ;
  wire \lpf_acc_reg[27]_i_1_n_7 ;
  wire \lpf_acc_reg[31]_i_1_n_1 ;
  wire \lpf_acc_reg[31]_i_1_n_2 ;
  wire \lpf_acc_reg[31]_i_1_n_3 ;
  wire \lpf_acc_reg[31]_i_1_n_4 ;
  wire \lpf_acc_reg[31]_i_1_n_5 ;
  wire \lpf_acc_reg[31]_i_1_n_6 ;
  wire \lpf_acc_reg[31]_i_1_n_7 ;
  wire \lpf_acc_reg[4]_i_1_n_0 ;
  wire \lpf_acc_reg[4]_i_1_n_1 ;
  wire \lpf_acc_reg[4]_i_1_n_2 ;
  wire \lpf_acc_reg[4]_i_1_n_3 ;
  wire \lpf_acc_reg[4]_i_1_n_4 ;
  wire \lpf_acc_reg[4]_i_1_n_5 ;
  wire \lpf_acc_reg[4]_i_1_n_6 ;
  wire \lpf_acc_reg[4]_i_1_n_7 ;
  wire \lpf_acc_reg[8]_i_1_n_0 ;
  wire \lpf_acc_reg[8]_i_1_n_1 ;
  wire \lpf_acc_reg[8]_i_1_n_2 ;
  wire \lpf_acc_reg[8]_i_1_n_3 ;
  wire \lpf_acc_reg[8]_i_1_n_4 ;
  wire \lpf_acc_reg[8]_i_1_n_5 ;
  wire \lpf_acc_reg[8]_i_1_n_6 ;
  wire \lpf_acc_reg[8]_i_1_n_7 ;
  wire pfd_dn;
  wire pfd_up;
  wire [31:1]pi_sum;
  wire rst_n;
  wire [3:0]NLW_ARG_carry_O_UNCONNECTED;
  wire [3:2]NLW_ARG_carry__6_CO_UNCONNECTED;
  wire [3:3]NLW_ARG_carry__6_O_UNCONNECTED;
  wire [0:0]\NLW_integrator_reg[1]_i_1_O_UNCONNECTED ;
  wire [3:3]\NLW_integrator_reg[28]_i_1_CO_UNCONNECTED ;
  wire [3:3]\NLW_lpf_acc_reg[31]_i_1_CO_UNCONNECTED ;

  (* ADDER_THRESHOLD = "35" *) 
  CARRY4 ARG_carry
       (.CI(1'b0),
        .CO({ARG_carry_n_0,ARG_carry_n_1,ARG_carry_n_2,ARG_carry_n_3}),
        .CYINIT(ARG_carry_i_1_n_0),
        .DI(pi_sum[4:1]),
        .O(NLW_ARG_carry_O_UNCONNECTED[3:0]),
        .S({ARG_carry_i_2_n_0,ARG_carry_i_3_n_0,ARG_carry_i_4_n_0,ARG_carry_i_5_n_0}));
  (* ADDER_THRESHOLD = "35" *) 
  CARRY4 ARG_carry__0
       (.CI(ARG_carry_n_0),
        .CO({ARG_carry__0_n_0,ARG_carry__0_n_1,ARG_carry__0_n_2,ARG_carry__0_n_3}),
        .CYINIT(1'b0),
        .DI(pi_sum[8:5]),
        .O({ARG_carry__0_n_4,ARG_carry__0_n_5,ARG_carry__0_n_6,ARG_carry__0_n_7}),
        .S({ARG_carry__0_i_1_n_0,ARG_carry__0_i_2_n_0,ARG_carry__0_i_3_n_0,ARG_carry__0_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__0_i_1
       (.I0(pi_sum[8]),
        .I1(lpf_acc_reg[8]),
        .O(ARG_carry__0_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__0_i_2
       (.I0(pi_sum[7]),
        .I1(lpf_acc_reg[7]),
        .O(ARG_carry__0_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__0_i_3
       (.I0(pi_sum[6]),
        .I1(lpf_acc_reg[6]),
        .O(ARG_carry__0_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__0_i_4
       (.I0(pi_sum[5]),
        .I1(lpf_acc_reg[5]),
        .O(ARG_carry__0_i_4_n_0));
  (* ADDER_THRESHOLD = "35" *) 
  CARRY4 ARG_carry__1
       (.CI(ARG_carry__0_n_0),
        .CO({ARG_carry__1_n_0,ARG_carry__1_n_1,ARG_carry__1_n_2,ARG_carry__1_n_3}),
        .CYINIT(1'b0),
        .DI(pi_sum[12:9]),
        .O({ARG_carry__1_n_4,ARG_carry__1_n_5,ARG_carry__1_n_6,ARG_carry__1_n_7}),
        .S({ARG_carry__1_i_1_n_0,ARG_carry__1_i_2_n_0,ARG_carry__1_i_3_n_0,ARG_carry__1_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__1_i_1
       (.I0(pi_sum[12]),
        .I1(lpf_acc_reg[12]),
        .O(ARG_carry__1_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__1_i_2
       (.I0(pi_sum[11]),
        .I1(lpf_acc_reg[11]),
        .O(ARG_carry__1_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__1_i_3
       (.I0(pi_sum[10]),
        .I1(lpf_acc_reg[10]),
        .O(ARG_carry__1_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__1_i_4
       (.I0(pi_sum[9]),
        .I1(lpf_acc_reg[9]),
        .O(ARG_carry__1_i_4_n_0));
  (* ADDER_THRESHOLD = "35" *) 
  CARRY4 ARG_carry__2
       (.CI(ARG_carry__1_n_0),
        .CO({ARG_carry__2_n_0,ARG_carry__2_n_1,ARG_carry__2_n_2,ARG_carry__2_n_3}),
        .CYINIT(1'b0),
        .DI(pi_sum[16:13]),
        .O({ARG_carry__2_n_4,ARG_carry__2_n_5,ARG_carry__2_n_6,ARG_carry__2_n_7}),
        .S({ARG_carry__2_i_1_n_0,ARG_carry__2_i_2_n_0,ARG_carry__2_i_3_n_0,ARG_carry__2_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__2_i_1
       (.I0(pi_sum[16]),
        .I1(ctrl_out[0]),
        .O(ARG_carry__2_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__2_i_2
       (.I0(pi_sum[15]),
        .I1(lpf_acc_reg[15]),
        .O(ARG_carry__2_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__2_i_3
       (.I0(pi_sum[14]),
        .I1(lpf_acc_reg[14]),
        .O(ARG_carry__2_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__2_i_4
       (.I0(pi_sum[13]),
        .I1(lpf_acc_reg[13]),
        .O(ARG_carry__2_i_4_n_0));
  (* ADDER_THRESHOLD = "35" *) 
  CARRY4 ARG_carry__3
       (.CI(ARG_carry__2_n_0),
        .CO({ARG_carry__3_n_0,ARG_carry__3_n_1,ARG_carry__3_n_2,ARG_carry__3_n_3}),
        .CYINIT(1'b0),
        .DI(pi_sum[20:17]),
        .O({ARG_carry__3_n_4,ARG_carry__3_n_5,ARG_carry__3_n_6,ARG_carry__3_n_7}),
        .S({ARG_carry__3_i_1_n_0,ARG_carry__3_i_2_n_0,ARG_carry__3_i_3_n_0,ARG_carry__3_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__3_i_1
       (.I0(pi_sum[20]),
        .I1(ctrl_out[4]),
        .O(ARG_carry__3_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__3_i_2
       (.I0(pi_sum[19]),
        .I1(ctrl_out[3]),
        .O(ARG_carry__3_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__3_i_3
       (.I0(pi_sum[18]),
        .I1(ctrl_out[2]),
        .O(ARG_carry__3_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__3_i_4
       (.I0(pi_sum[17]),
        .I1(ctrl_out[1]),
        .O(ARG_carry__3_i_4_n_0));
  (* ADDER_THRESHOLD = "35" *) 
  CARRY4 ARG_carry__4
       (.CI(ARG_carry__3_n_0),
        .CO({ARG_carry__4_n_0,ARG_carry__4_n_1,ARG_carry__4_n_2,ARG_carry__4_n_3}),
        .CYINIT(1'b0),
        .DI(pi_sum[24:21]),
        .O({ARG_carry__4_n_4,ARG_carry__4_n_5,ARG_carry__4_n_6,ARG_carry__4_n_7}),
        .S({ARG_carry__4_i_1_n_0,ARG_carry__4_i_2_n_0,ARG_carry__4_i_3_n_0,ARG_carry__4_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__4_i_1
       (.I0(pi_sum[24]),
        .I1(ctrl_out[8]),
        .O(ARG_carry__4_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__4_i_2
       (.I0(pi_sum[23]),
        .I1(ctrl_out[7]),
        .O(ARG_carry__4_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__4_i_3
       (.I0(pi_sum[22]),
        .I1(ctrl_out[6]),
        .O(ARG_carry__4_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__4_i_4
       (.I0(pi_sum[21]),
        .I1(ctrl_out[5]),
        .O(ARG_carry__4_i_4_n_0));
  (* ADDER_THRESHOLD = "35" *) 
  CARRY4 ARG_carry__5
       (.CI(ARG_carry__4_n_0),
        .CO({ARG_carry__5_n_0,ARG_carry__5_n_1,ARG_carry__5_n_2,ARG_carry__5_n_3}),
        .CYINIT(1'b0),
        .DI(pi_sum[28:25]),
        .O({ARG_carry__5_n_4,ARG_carry__5_n_5,ARG_carry__5_n_6,ARG_carry__5_n_7}),
        .S({ARG_carry__5_i_1_n_0,ARG_carry__5_i_2_n_0,ARG_carry__5_i_3_n_0,ARG_carry__5_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__5_i_1
       (.I0(pi_sum[28]),
        .I1(ctrl_out[12]),
        .O(ARG_carry__5_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__5_i_2
       (.I0(pi_sum[27]),
        .I1(ctrl_out[11]),
        .O(ARG_carry__5_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__5_i_3
       (.I0(pi_sum[26]),
        .I1(ctrl_out[10]),
        .O(ARG_carry__5_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__5_i_4
       (.I0(pi_sum[25]),
        .I1(ctrl_out[9]),
        .O(ARG_carry__5_i_4_n_0));
  (* ADDER_THRESHOLD = "35" *) 
  CARRY4 ARG_carry__6
       (.CI(ARG_carry__5_n_0),
        .CO({NLW_ARG_carry__6_CO_UNCONNECTED[3:2],ARG_carry__6_n_2,ARG_carry__6_n_3}),
        .CYINIT(1'b0),
        .DI({1'b0,1'b0,pi_sum[30:29]}),
        .O({NLW_ARG_carry__6_O_UNCONNECTED[3],in0,ARG_carry__6_n_6,ARG_carry__6_n_7}),
        .S({1'b0,ARG_carry__6_i_1_n_0,ARG_carry__6_i_2_n_0,ARG_carry__6_i_3_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__6_i_1
       (.I0(pi_sum[31]),
        .I1(ctrl_out[15]),
        .O(ARG_carry__6_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__6_i_2
       (.I0(pi_sum[30]),
        .I1(ctrl_out[14]),
        .O(ARG_carry__6_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry__6_i_3
       (.I0(pi_sum[29]),
        .I1(ctrl_out[13]),
        .O(ARG_carry__6_i_3_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    ARG_carry_i_1
       (.I0(lpf_acc_reg[0]),
        .O(ARG_carry_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry_i_2
       (.I0(pi_sum[4]),
        .I1(lpf_acc_reg[4]),
        .O(ARG_carry_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry_i_3
       (.I0(pi_sum[3]),
        .I1(lpf_acc_reg[3]),
        .O(ARG_carry_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry_i_4
       (.I0(pi_sum[2]),
        .I1(lpf_acc_reg[2]),
        .O(ARG_carry_i_4_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    ARG_carry_i_5
       (.I0(pi_sum[1]),
        .I1(lpf_acc_reg[1]),
        .O(ARG_carry_i_5_n_0));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[12]_i_2 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[15]),
        .O(\integrator[12]_i_2_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[12]_i_3 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[14]),
        .O(\integrator[12]_i_3_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[12]_i_4 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[13]),
        .O(\integrator[12]_i_4_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[12]_i_5 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[12]),
        .O(\integrator[12]_i_5_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[16]_i_2 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[19]),
        .O(\integrator[16]_i_2_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[16]_i_3 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[18]),
        .O(\integrator[16]_i_3_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[16]_i_4 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[17]),
        .O(\integrator[16]_i_4_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[16]_i_5 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[16]),
        .O(\integrator[16]_i_5_n_0 ));
  LUT3 #(
    .INIT(8'hD2)) 
    \integrator[1]_i_2 
       (.I0(pfd_dn),
        .I1(pfd_up),
        .I2(integrator_reg[3]),
        .O(\integrator[1]_i_2_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[1]_i_3 
       (.I0(pfd_dn),
        .I1(pfd_up),
        .I2(integrator_reg[2]),
        .O(\integrator[1]_i_3_n_0 ));
  LUT3 #(
    .INIT(8'h96)) 
    \integrator[1]_i_4 
       (.I0(pfd_dn),
        .I1(pfd_up),
        .I2(integrator_reg[1]),
        .O(\integrator[1]_i_4_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[20]_i_2 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[23]),
        .O(\integrator[20]_i_2_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[20]_i_3 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[22]),
        .O(\integrator[20]_i_3_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[20]_i_4 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[21]),
        .O(\integrator[20]_i_4_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[20]_i_5 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[20]),
        .O(\integrator[20]_i_5_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[24]_i_2 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[27]),
        .O(\integrator[24]_i_2_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[24]_i_3 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[26]),
        .O(\integrator[24]_i_3_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[24]_i_4 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[25]),
        .O(\integrator[24]_i_4_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[24]_i_5 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[24]),
        .O(\integrator[24]_i_5_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[28]_i_2 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[31]),
        .O(\integrator[28]_i_2_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[28]_i_3 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[30]),
        .O(\integrator[28]_i_3_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[28]_i_4 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[29]),
        .O(\integrator[28]_i_4_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[28]_i_5 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[28]),
        .O(\integrator[28]_i_5_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[4]_i_2 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[7]),
        .O(\integrator[4]_i_2_n_0 ));
  LUT3 #(
    .INIT(8'hD2)) 
    \integrator[4]_i_3 
       (.I0(pfd_dn),
        .I1(pfd_up),
        .I2(integrator_reg[6]),
        .O(\integrator[4]_i_3_n_0 ));
  LUT3 #(
    .INIT(8'hD2)) 
    \integrator[4]_i_4 
       (.I0(pfd_dn),
        .I1(pfd_up),
        .I2(integrator_reg[5]),
        .O(\integrator[4]_i_4_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[4]_i_5 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[4]),
        .O(\integrator[4]_i_5_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[8]_i_2 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[11]),
        .O(\integrator[8]_i_2_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[8]_i_3 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[10]),
        .O(\integrator[8]_i_3_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[8]_i_4 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[9]),
        .O(\integrator[8]_i_4_n_0 ));
  LUT3 #(
    .INIT(8'hB4)) 
    \integrator[8]_i_5 
       (.I0(pfd_up),
        .I1(pfd_dn),
        .I2(integrator_reg[8]),
        .O(\integrator[8]_i_5_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[10] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[8]_i_1_n_5 ),
        .Q(integrator_reg[10]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[11] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[8]_i_1_n_4 ),
        .Q(integrator_reg[11]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[12] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[12]_i_1_n_7 ),
        .Q(integrator_reg[12]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \integrator_reg[12]_i_1 
       (.CI(\integrator_reg[8]_i_1_n_0 ),
        .CO({\integrator_reg[12]_i_1_n_0 ,\integrator_reg[12]_i_1_n_1 ,\integrator_reg[12]_i_1_n_2 ,\integrator_reg[12]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI(integrator_reg[15:12]),
        .O({\integrator_reg[12]_i_1_n_4 ,\integrator_reg[12]_i_1_n_5 ,\integrator_reg[12]_i_1_n_6 ,\integrator_reg[12]_i_1_n_7 }),
        .S({\integrator[12]_i_2_n_0 ,\integrator[12]_i_3_n_0 ,\integrator[12]_i_4_n_0 ,\integrator[12]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[13] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[12]_i_1_n_6 ),
        .Q(integrator_reg[13]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[14] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[12]_i_1_n_5 ),
        .Q(integrator_reg[14]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[15] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[12]_i_1_n_4 ),
        .Q(integrator_reg[15]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[16] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[16]_i_1_n_7 ),
        .Q(integrator_reg[16]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \integrator_reg[16]_i_1 
       (.CI(\integrator_reg[12]_i_1_n_0 ),
        .CO({\integrator_reg[16]_i_1_n_0 ,\integrator_reg[16]_i_1_n_1 ,\integrator_reg[16]_i_1_n_2 ,\integrator_reg[16]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI(integrator_reg[19:16]),
        .O({\integrator_reg[16]_i_1_n_4 ,\integrator_reg[16]_i_1_n_5 ,\integrator_reg[16]_i_1_n_6 ,\integrator_reg[16]_i_1_n_7 }),
        .S({\integrator[16]_i_2_n_0 ,\integrator[16]_i_3_n_0 ,\integrator[16]_i_4_n_0 ,\integrator[16]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[17] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[16]_i_1_n_6 ),
        .Q(integrator_reg[17]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[18] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[16]_i_1_n_5 ),
        .Q(integrator_reg[18]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[19] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[16]_i_1_n_4 ),
        .Q(integrator_reg[19]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[1] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[1]_i_1_n_6 ),
        .Q(integrator_reg[1]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \integrator_reg[1]_i_1 
       (.CI(1'b0),
        .CO({\integrator_reg[1]_i_1_n_0 ,\integrator_reg[1]_i_1_n_1 ,\integrator_reg[1]_i_1_n_2 ,\integrator_reg[1]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({integrator_reg[3:1],1'b0}),
        .O({\integrator_reg[1]_i_1_n_4 ,\integrator_reg[1]_i_1_n_5 ,\integrator_reg[1]_i_1_n_6 ,\NLW_integrator_reg[1]_i_1_O_UNCONNECTED [0]}),
        .S({\integrator[1]_i_2_n_0 ,\integrator[1]_i_3_n_0 ,\integrator[1]_i_4_n_0 ,1'b0}));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[20] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[20]_i_1_n_7 ),
        .Q(integrator_reg[20]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \integrator_reg[20]_i_1 
       (.CI(\integrator_reg[16]_i_1_n_0 ),
        .CO({\integrator_reg[20]_i_1_n_0 ,\integrator_reg[20]_i_1_n_1 ,\integrator_reg[20]_i_1_n_2 ,\integrator_reg[20]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI(integrator_reg[23:20]),
        .O({\integrator_reg[20]_i_1_n_4 ,\integrator_reg[20]_i_1_n_5 ,\integrator_reg[20]_i_1_n_6 ,\integrator_reg[20]_i_1_n_7 }),
        .S({\integrator[20]_i_2_n_0 ,\integrator[20]_i_3_n_0 ,\integrator[20]_i_4_n_0 ,\integrator[20]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[21] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[20]_i_1_n_6 ),
        .Q(integrator_reg[21]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[22] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[20]_i_1_n_5 ),
        .Q(integrator_reg[22]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[23] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[20]_i_1_n_4 ),
        .Q(integrator_reg[23]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[24] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[24]_i_1_n_7 ),
        .Q(integrator_reg[24]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \integrator_reg[24]_i_1 
       (.CI(\integrator_reg[20]_i_1_n_0 ),
        .CO({\integrator_reg[24]_i_1_n_0 ,\integrator_reg[24]_i_1_n_1 ,\integrator_reg[24]_i_1_n_2 ,\integrator_reg[24]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI(integrator_reg[27:24]),
        .O({\integrator_reg[24]_i_1_n_4 ,\integrator_reg[24]_i_1_n_5 ,\integrator_reg[24]_i_1_n_6 ,\integrator_reg[24]_i_1_n_7 }),
        .S({\integrator[24]_i_2_n_0 ,\integrator[24]_i_3_n_0 ,\integrator[24]_i_4_n_0 ,\integrator[24]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[25] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[24]_i_1_n_6 ),
        .Q(integrator_reg[25]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[26] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[24]_i_1_n_5 ),
        .Q(integrator_reg[26]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[27] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[24]_i_1_n_4 ),
        .Q(integrator_reg[27]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[28] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[28]_i_1_n_7 ),
        .Q(integrator_reg[28]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \integrator_reg[28]_i_1 
       (.CI(\integrator_reg[24]_i_1_n_0 ),
        .CO({\NLW_integrator_reg[28]_i_1_CO_UNCONNECTED [3],\integrator_reg[28]_i_1_n_1 ,\integrator_reg[28]_i_1_n_2 ,\integrator_reg[28]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({1'b0,integrator_reg[30:28]}),
        .O({\integrator_reg[28]_i_1_n_4 ,\integrator_reg[28]_i_1_n_5 ,\integrator_reg[28]_i_1_n_6 ,\integrator_reg[28]_i_1_n_7 }),
        .S({\integrator[28]_i_2_n_0 ,\integrator[28]_i_3_n_0 ,\integrator[28]_i_4_n_0 ,\integrator[28]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[29] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[28]_i_1_n_6 ),
        .Q(integrator_reg[29]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[2] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[1]_i_1_n_5 ),
        .Q(integrator_reg[2]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[30] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[28]_i_1_n_5 ),
        .Q(integrator_reg[30]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[31] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[28]_i_1_n_4 ),
        .Q(integrator_reg[31]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[3] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[1]_i_1_n_4 ),
        .Q(integrator_reg[3]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[4] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[4]_i_1_n_7 ),
        .Q(integrator_reg[4]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \integrator_reg[4]_i_1 
       (.CI(\integrator_reg[1]_i_1_n_0 ),
        .CO({\integrator_reg[4]_i_1_n_0 ,\integrator_reg[4]_i_1_n_1 ,\integrator_reg[4]_i_1_n_2 ,\integrator_reg[4]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI(integrator_reg[7:4]),
        .O({\integrator_reg[4]_i_1_n_4 ,\integrator_reg[4]_i_1_n_5 ,\integrator_reg[4]_i_1_n_6 ,\integrator_reg[4]_i_1_n_7 }),
        .S({\integrator[4]_i_2_n_0 ,\integrator[4]_i_3_n_0 ,\integrator[4]_i_4_n_0 ,\integrator[4]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[5] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[4]_i_1_n_6 ),
        .Q(integrator_reg[5]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[6] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[4]_i_1_n_5 ),
        .Q(integrator_reg[6]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[7] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[4]_i_1_n_4 ),
        .Q(integrator_reg[7]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[8] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[8]_i_1_n_7 ),
        .Q(integrator_reg[8]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \integrator_reg[8]_i_1 
       (.CI(\integrator_reg[4]_i_1_n_0 ),
        .CO({\integrator_reg[8]_i_1_n_0 ,\integrator_reg[8]_i_1_n_1 ,\integrator_reg[8]_i_1_n_2 ,\integrator_reg[8]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI(integrator_reg[11:8]),
        .O({\integrator_reg[8]_i_1_n_4 ,\integrator_reg[8]_i_1_n_5 ,\integrator_reg[8]_i_1_n_6 ,\integrator_reg[8]_i_1_n_7 }),
        .S({\integrator[8]_i_2_n_0 ,\integrator[8]_i_3_n_0 ,\integrator[8]_i_4_n_0 ,\integrator[8]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \integrator_reg[9] 
       (.C(clk),
        .CE(1'b1),
        .D(\integrator_reg[8]_i_1_n_6 ),
        .Q(integrator_reg[9]),
        .R(rst_n));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[0]_i_2 
       (.I0(ARG_carry__0_n_4),
        .I1(lpf_acc_reg[3]),
        .O(\lpf_acc[0]_i_2_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[0]_i_3 
       (.I0(ARG_carry__0_n_5),
        .I1(lpf_acc_reg[2]),
        .O(\lpf_acc[0]_i_3_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[0]_i_4 
       (.I0(ARG_carry__0_n_6),
        .I1(lpf_acc_reg[1]),
        .O(\lpf_acc[0]_i_4_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[0]_i_5 
       (.I0(ARG_carry__0_n_7),
        .I1(lpf_acc_reg[0]),
        .O(\lpf_acc[0]_i_5_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[12]_i_2 
       (.I0(ARG_carry__3_n_4),
        .I1(lpf_acc_reg[15]),
        .O(\lpf_acc[12]_i_2_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[12]_i_3 
       (.I0(ARG_carry__3_n_5),
        .I1(lpf_acc_reg[14]),
        .O(\lpf_acc[12]_i_3_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[12]_i_4 
       (.I0(ARG_carry__3_n_6),
        .I1(lpf_acc_reg[13]),
        .O(\lpf_acc[12]_i_4_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[12]_i_5 
       (.I0(ARG_carry__3_n_7),
        .I1(lpf_acc_reg[12]),
        .O(\lpf_acc[12]_i_5_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[19]_i_2 
       (.I0(ARG_carry__4_n_4),
        .I1(ctrl_out[3]),
        .O(\lpf_acc[19]_i_2_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[19]_i_3 
       (.I0(ARG_carry__4_n_5),
        .I1(ctrl_out[2]),
        .O(\lpf_acc[19]_i_3_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[19]_i_4 
       (.I0(ARG_carry__4_n_6),
        .I1(ctrl_out[1]),
        .O(\lpf_acc[19]_i_4_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[19]_i_5 
       (.I0(ARG_carry__4_n_7),
        .I1(ctrl_out[0]),
        .O(\lpf_acc[19]_i_5_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[23]_i_2 
       (.I0(ARG_carry__5_n_4),
        .I1(ctrl_out[7]),
        .O(\lpf_acc[23]_i_2_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[23]_i_3 
       (.I0(ARG_carry__5_n_5),
        .I1(ctrl_out[6]),
        .O(\lpf_acc[23]_i_3_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[23]_i_4 
       (.I0(ARG_carry__5_n_6),
        .I1(ctrl_out[5]),
        .O(\lpf_acc[23]_i_4_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[23]_i_5 
       (.I0(ARG_carry__5_n_7),
        .I1(ctrl_out[4]),
        .O(\lpf_acc[23]_i_5_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[27]_i_2 
       (.I0(in0),
        .I1(ctrl_out[11]),
        .O(\lpf_acc[27]_i_2_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[27]_i_3 
       (.I0(in0),
        .I1(ctrl_out[10]),
        .O(\lpf_acc[27]_i_3_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[27]_i_4 
       (.I0(ARG_carry__6_n_6),
        .I1(ctrl_out[9]),
        .O(\lpf_acc[27]_i_4_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[27]_i_5 
       (.I0(ARG_carry__6_n_7),
        .I1(ctrl_out[8]),
        .O(\lpf_acc[27]_i_5_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[31]_i_2 
       (.I0(in0),
        .I1(ctrl_out[15]),
        .O(\lpf_acc[31]_i_2_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[31]_i_3 
       (.I0(in0),
        .I1(ctrl_out[14]),
        .O(\lpf_acc[31]_i_3_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[31]_i_4 
       (.I0(in0),
        .I1(ctrl_out[13]),
        .O(\lpf_acc[31]_i_4_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[31]_i_5 
       (.I0(in0),
        .I1(ctrl_out[12]),
        .O(\lpf_acc[31]_i_5_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[4]_i_2 
       (.I0(ARG_carry__1_n_4),
        .I1(lpf_acc_reg[7]),
        .O(\lpf_acc[4]_i_2_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[4]_i_3 
       (.I0(ARG_carry__1_n_5),
        .I1(lpf_acc_reg[6]),
        .O(\lpf_acc[4]_i_3_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[4]_i_4 
       (.I0(ARG_carry__1_n_6),
        .I1(lpf_acc_reg[5]),
        .O(\lpf_acc[4]_i_4_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[4]_i_5 
       (.I0(ARG_carry__1_n_7),
        .I1(lpf_acc_reg[4]),
        .O(\lpf_acc[4]_i_5_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[8]_i_2 
       (.I0(ARG_carry__2_n_4),
        .I1(lpf_acc_reg[11]),
        .O(\lpf_acc[8]_i_2_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[8]_i_3 
       (.I0(ARG_carry__2_n_5),
        .I1(lpf_acc_reg[10]),
        .O(\lpf_acc[8]_i_3_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[8]_i_4 
       (.I0(ARG_carry__2_n_6),
        .I1(lpf_acc_reg[9]),
        .O(\lpf_acc[8]_i_4_n_0 ));
  LUT2 #(
    .INIT(4'h6)) 
    \lpf_acc[8]_i_5 
       (.I0(ARG_carry__2_n_7),
        .I1(lpf_acc_reg[8]),
        .O(\lpf_acc[8]_i_5_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[0] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[0]_i_1_n_7 ),
        .Q(lpf_acc_reg[0]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \lpf_acc_reg[0]_i_1 
       (.CI(1'b0),
        .CO({\lpf_acc_reg[0]_i_1_n_0 ,\lpf_acc_reg[0]_i_1_n_1 ,\lpf_acc_reg[0]_i_1_n_2 ,\lpf_acc_reg[0]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({ARG_carry__0_n_4,ARG_carry__0_n_5,ARG_carry__0_n_6,ARG_carry__0_n_7}),
        .O({\lpf_acc_reg[0]_i_1_n_4 ,\lpf_acc_reg[0]_i_1_n_5 ,\lpf_acc_reg[0]_i_1_n_6 ,\lpf_acc_reg[0]_i_1_n_7 }),
        .S({\lpf_acc[0]_i_2_n_0 ,\lpf_acc[0]_i_3_n_0 ,\lpf_acc[0]_i_4_n_0 ,\lpf_acc[0]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[10] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[8]_i_1_n_5 ),
        .Q(lpf_acc_reg[10]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[11] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[8]_i_1_n_4 ),
        .Q(lpf_acc_reg[11]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[12] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[12]_i_1_n_7 ),
        .Q(lpf_acc_reg[12]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \lpf_acc_reg[12]_i_1 
       (.CI(\lpf_acc_reg[8]_i_1_n_0 ),
        .CO({\lpf_acc_reg[12]_i_1_n_0 ,\lpf_acc_reg[12]_i_1_n_1 ,\lpf_acc_reg[12]_i_1_n_2 ,\lpf_acc_reg[12]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({ARG_carry__3_n_4,ARG_carry__3_n_5,ARG_carry__3_n_6,ARG_carry__3_n_7}),
        .O({\lpf_acc_reg[12]_i_1_n_4 ,\lpf_acc_reg[12]_i_1_n_5 ,\lpf_acc_reg[12]_i_1_n_6 ,\lpf_acc_reg[12]_i_1_n_7 }),
        .S({\lpf_acc[12]_i_2_n_0 ,\lpf_acc[12]_i_3_n_0 ,\lpf_acc[12]_i_4_n_0 ,\lpf_acc[12]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[13] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[12]_i_1_n_6 ),
        .Q(lpf_acc_reg[13]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[14] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[12]_i_1_n_5 ),
        .Q(lpf_acc_reg[14]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[15] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[12]_i_1_n_4 ),
        .Q(lpf_acc_reg[15]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[16] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[19]_i_1_n_7 ),
        .Q(ctrl_out[0]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[17] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[19]_i_1_n_6 ),
        .Q(ctrl_out[1]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[18] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[19]_i_1_n_5 ),
        .Q(ctrl_out[2]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[19] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[19]_i_1_n_4 ),
        .Q(ctrl_out[3]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \lpf_acc_reg[19]_i_1 
       (.CI(\lpf_acc_reg[12]_i_1_n_0 ),
        .CO({\lpf_acc_reg[19]_i_1_n_0 ,\lpf_acc_reg[19]_i_1_n_1 ,\lpf_acc_reg[19]_i_1_n_2 ,\lpf_acc_reg[19]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({ARG_carry__4_n_4,ARG_carry__4_n_5,ARG_carry__4_n_6,ARG_carry__4_n_7}),
        .O({\lpf_acc_reg[19]_i_1_n_4 ,\lpf_acc_reg[19]_i_1_n_5 ,\lpf_acc_reg[19]_i_1_n_6 ,\lpf_acc_reg[19]_i_1_n_7 }),
        .S({\lpf_acc[19]_i_2_n_0 ,\lpf_acc[19]_i_3_n_0 ,\lpf_acc[19]_i_4_n_0 ,\lpf_acc[19]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[1] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[0]_i_1_n_6 ),
        .Q(lpf_acc_reg[1]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[20] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[23]_i_1_n_7 ),
        .Q(ctrl_out[4]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[21] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[23]_i_1_n_6 ),
        .Q(ctrl_out[5]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[22] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[23]_i_1_n_5 ),
        .Q(ctrl_out[6]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[23] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[23]_i_1_n_4 ),
        .Q(ctrl_out[7]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \lpf_acc_reg[23]_i_1 
       (.CI(\lpf_acc_reg[19]_i_1_n_0 ),
        .CO({\lpf_acc_reg[23]_i_1_n_0 ,\lpf_acc_reg[23]_i_1_n_1 ,\lpf_acc_reg[23]_i_1_n_2 ,\lpf_acc_reg[23]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({ARG_carry__5_n_4,ARG_carry__5_n_5,ARG_carry__5_n_6,ARG_carry__5_n_7}),
        .O({\lpf_acc_reg[23]_i_1_n_4 ,\lpf_acc_reg[23]_i_1_n_5 ,\lpf_acc_reg[23]_i_1_n_6 ,\lpf_acc_reg[23]_i_1_n_7 }),
        .S({\lpf_acc[23]_i_2_n_0 ,\lpf_acc[23]_i_3_n_0 ,\lpf_acc[23]_i_4_n_0 ,\lpf_acc[23]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[24] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[27]_i_1_n_7 ),
        .Q(ctrl_out[8]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[25] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[27]_i_1_n_6 ),
        .Q(ctrl_out[9]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[26] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[27]_i_1_n_5 ),
        .Q(ctrl_out[10]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[27] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[27]_i_1_n_4 ),
        .Q(ctrl_out[11]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \lpf_acc_reg[27]_i_1 
       (.CI(\lpf_acc_reg[23]_i_1_n_0 ),
        .CO({\lpf_acc_reg[27]_i_1_n_0 ,\lpf_acc_reg[27]_i_1_n_1 ,\lpf_acc_reg[27]_i_1_n_2 ,\lpf_acc_reg[27]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({in0,in0,ARG_carry__6_n_6,ARG_carry__6_n_7}),
        .O({\lpf_acc_reg[27]_i_1_n_4 ,\lpf_acc_reg[27]_i_1_n_5 ,\lpf_acc_reg[27]_i_1_n_6 ,\lpf_acc_reg[27]_i_1_n_7 }),
        .S({\lpf_acc[27]_i_2_n_0 ,\lpf_acc[27]_i_3_n_0 ,\lpf_acc[27]_i_4_n_0 ,\lpf_acc[27]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[28] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[31]_i_1_n_7 ),
        .Q(ctrl_out[12]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[29] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[31]_i_1_n_6 ),
        .Q(ctrl_out[13]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[2] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[0]_i_1_n_5 ),
        .Q(lpf_acc_reg[2]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[30] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[31]_i_1_n_5 ),
        .Q(ctrl_out[14]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[31] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[31]_i_1_n_4 ),
        .Q(ctrl_out[15]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \lpf_acc_reg[31]_i_1 
       (.CI(\lpf_acc_reg[27]_i_1_n_0 ),
        .CO({\NLW_lpf_acc_reg[31]_i_1_CO_UNCONNECTED [3],\lpf_acc_reg[31]_i_1_n_1 ,\lpf_acc_reg[31]_i_1_n_2 ,\lpf_acc_reg[31]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({1'b0,in0,in0,in0}),
        .O({\lpf_acc_reg[31]_i_1_n_4 ,\lpf_acc_reg[31]_i_1_n_5 ,\lpf_acc_reg[31]_i_1_n_6 ,\lpf_acc_reg[31]_i_1_n_7 }),
        .S({\lpf_acc[31]_i_2_n_0 ,\lpf_acc[31]_i_3_n_0 ,\lpf_acc[31]_i_4_n_0 ,\lpf_acc[31]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[3] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[0]_i_1_n_4 ),
        .Q(lpf_acc_reg[3]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[4] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[4]_i_1_n_7 ),
        .Q(lpf_acc_reg[4]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \lpf_acc_reg[4]_i_1 
       (.CI(\lpf_acc_reg[0]_i_1_n_0 ),
        .CO({\lpf_acc_reg[4]_i_1_n_0 ,\lpf_acc_reg[4]_i_1_n_1 ,\lpf_acc_reg[4]_i_1_n_2 ,\lpf_acc_reg[4]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({ARG_carry__1_n_4,ARG_carry__1_n_5,ARG_carry__1_n_6,ARG_carry__1_n_7}),
        .O({\lpf_acc_reg[4]_i_1_n_4 ,\lpf_acc_reg[4]_i_1_n_5 ,\lpf_acc_reg[4]_i_1_n_6 ,\lpf_acc_reg[4]_i_1_n_7 }),
        .S({\lpf_acc[4]_i_2_n_0 ,\lpf_acc[4]_i_3_n_0 ,\lpf_acc[4]_i_4_n_0 ,\lpf_acc[4]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[5] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[4]_i_1_n_6 ),
        .Q(lpf_acc_reg[5]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[6] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[4]_i_1_n_5 ),
        .Q(lpf_acc_reg[6]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[7] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[4]_i_1_n_4 ),
        .Q(lpf_acc_reg[7]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[8] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[8]_i_1_n_7 ),
        .Q(lpf_acc_reg[8]),
        .R(rst_n));
  (* ADDER_THRESHOLD = "11" *) 
  CARRY4 \lpf_acc_reg[8]_i_1 
       (.CI(\lpf_acc_reg[4]_i_1_n_0 ),
        .CO({\lpf_acc_reg[8]_i_1_n_0 ,\lpf_acc_reg[8]_i_1_n_1 ,\lpf_acc_reg[8]_i_1_n_2 ,\lpf_acc_reg[8]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({ARG_carry__2_n_4,ARG_carry__2_n_5,ARG_carry__2_n_6,ARG_carry__2_n_7}),
        .O({\lpf_acc_reg[8]_i_1_n_4 ,\lpf_acc_reg[8]_i_1_n_5 ,\lpf_acc_reg[8]_i_1_n_6 ,\lpf_acc_reg[8]_i_1_n_7 }),
        .S({\lpf_acc[8]_i_2_n_0 ,\lpf_acc[8]_i_3_n_0 ,\lpf_acc[8]_i_4_n_0 ,\lpf_acc[8]_i_5_n_0 }));
  FDRE #(
    .INIT(1'b0)) 
    \lpf_acc_reg[9] 
       (.C(clk),
        .CE(1'b1),
        .D(\lpf_acc_reg[8]_i_1_n_6 ),
        .Q(lpf_acc_reg[9]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[10] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[10]),
        .Q(pi_sum[10]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[11] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[11]),
        .Q(pi_sum[11]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[12] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[12]),
        .Q(pi_sum[12]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[13] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[13]),
        .Q(pi_sum[13]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[14] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[14]),
        .Q(pi_sum[14]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[15] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[15]),
        .Q(pi_sum[15]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[16] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[16]),
        .Q(pi_sum[16]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[17] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[17]),
        .Q(pi_sum[17]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[18] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[18]),
        .Q(pi_sum[18]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[19] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[19]),
        .Q(pi_sum[19]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[1] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[1]),
        .Q(pi_sum[1]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[20] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[20]),
        .Q(pi_sum[20]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[21] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[21]),
        .Q(pi_sum[21]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[22] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[22]),
        .Q(pi_sum[22]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[23] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[23]),
        .Q(pi_sum[23]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[24] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[24]),
        .Q(pi_sum[24]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[25] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[25]),
        .Q(pi_sum[25]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[26] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[26]),
        .Q(pi_sum[26]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[27] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[27]),
        .Q(pi_sum[27]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[28] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[28]),
        .Q(pi_sum[28]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[29] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[29]),
        .Q(pi_sum[29]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[2] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[2]),
        .Q(pi_sum[2]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[30] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[30]),
        .Q(pi_sum[30]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[31] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[31]),
        .Q(pi_sum[31]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[3] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[3]),
        .Q(pi_sum[3]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[4] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[4]),
        .Q(pi_sum[4]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[5] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[5]),
        .Q(pi_sum[5]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[6] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[6]),
        .Q(pi_sum[6]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[7] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[7]),
        .Q(pi_sum[7]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[8] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[8]),
        .Q(pi_sum[8]),
        .R(rst_n));
  FDRE #(
    .INIT(1'b0)) 
    \pi_sum_reg[9] 
       (.C(clk),
        .CE(1'b1),
        .D(integrator_reg[9]),
        .Q(pi_sum[9]),
        .R(rst_n));
endmodule
`ifndef GLBL
`define GLBL
`timescale  1 ps / 1 ps

module glbl ();

    parameter ROC_WIDTH = 100000;
    parameter TOC_WIDTH = 0;
    parameter GRES_WIDTH = 10000;
    parameter GRES_START = 10000;

//--------   STARTUP Globals --------------
    wire GSR;
    wire GTS;
    wire GWE;
    wire PRLD;
    wire GRESTORE;
    tri1 p_up_tmp;
    tri (weak1, strong0) PLL_LOCKG = p_up_tmp;

    wire PROGB_GLBL;
    wire CCLKO_GLBL;
    wire FCSBO_GLBL;
    wire [3:0] DO_GLBL;
    wire [3:0] DI_GLBL;
   
    reg GSR_int;
    reg GTS_int;
    reg PRLD_int;
    reg GRESTORE_int;

//--------   JTAG Globals --------------
    wire JTAG_TDO_GLBL;
    wire JTAG_TCK_GLBL;
    wire JTAG_TDI_GLBL;
    wire JTAG_TMS_GLBL;
    wire JTAG_TRST_GLBL;

    reg JTAG_CAPTURE_GLBL;
    reg JTAG_RESET_GLBL;
    reg JTAG_SHIFT_GLBL;
    reg JTAG_UPDATE_GLBL;
    reg JTAG_RUNTEST_GLBL;

    reg JTAG_SEL1_GLBL = 0;
    reg JTAG_SEL2_GLBL = 0 ;
    reg JTAG_SEL3_GLBL = 0;
    reg JTAG_SEL4_GLBL = 0;

    reg JTAG_USER_TDO1_GLBL = 1'bz;
    reg JTAG_USER_TDO2_GLBL = 1'bz;
    reg JTAG_USER_TDO3_GLBL = 1'bz;
    reg JTAG_USER_TDO4_GLBL = 1'bz;

    assign (strong1, weak0) GSR = GSR_int;
    assign (strong1, weak0) GTS = GTS_int;
    assign (weak1, weak0) PRLD = PRLD_int;
    assign (strong1, weak0) GRESTORE = GRESTORE_int;

    initial begin
	GSR_int = 1'b1;
	PRLD_int = 1'b1;
	#(ROC_WIDTH)
	GSR_int = 1'b0;
	PRLD_int = 1'b0;
    end

    initial begin
	GTS_int = 1'b1;
	#(TOC_WIDTH)
	GTS_int = 1'b0;
    end

    initial begin 
	GRESTORE_int = 1'b0;
	#(GRES_START);
	GRESTORE_int = 1'b1;
	#(GRES_WIDTH);
	GRESTORE_int = 1'b0;
    end

endmodule
`endif
